package com.demoad.plugin_codelab.ASDK;

import static com.demoad.plugin_codelab.ASDK.ads.installedFromMarket;
import static com.demoad.plugin_codelab.adhelper.utils.Pack5AdsAvailability.isNetworkConnected;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.lifecycle.Lifecycle;
import androidx.lifecycle.LifecycleObserver;
import androidx.lifecycle.OnLifecycleEvent;
import androidx.lifecycle.ProcessLifecycleOwner;

import com.android.volley.AuthFailureError;
import com.android.volley.NetworkError;
import com.android.volley.NetworkResponse;
import com.android.volley.ParseError;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.ServerError;
import com.android.volley.TimeoutError;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.demoad.plugin_codelab.adhelper.ads.Pack5AdManager;
import com.demoad.plugin_codelab.adhelper.ads.Pack5AppOpenAds;
import com.demoad.plugin_codelab.adhelper.helpers.AdsLoadingDialog;
import com.demoad.plugin_codelab.adhelper.helpers.AudienceNetworkInitializeHelper;
import com.demoad.plugin_codelab.adhelper.helpers.SharedPreferencesClass;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsPreferenceClass;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsUtils;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AppOpenAdsListners;
import com.demoad.plugin_codelab.adhelper.utils.Pack5ConfigModel;
import com.facebook.ads.AudienceNetworkAds;
import com.google.android.gms.ads.AdError;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.FullScreenContentCallback;
import com.google.android.gms.ads.LoadAdError;
import com.google.android.gms.ads.MobileAds;
import com.google.android.gms.ads.RequestConfiguration;
import com.google.android.gms.ads.admanager.AdManagerAdRequest;
import com.google.android.gms.ads.admanager.AdManagerInterstitialAd;
import com.google.android.gms.ads.admanager.AdManagerInterstitialAdLoadCallback;
import com.google.android.gms.ads.appopen.AppOpenAd;
import com.google.android.gms.ads.interstitial.InterstitialAd;
import com.google.android.gms.ads.interstitial.InterstitialAdLoadCallback;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.openmediation.sdk.InitCallback;
import com.openmediation.sdk.InitConfiguration;
import com.openmediation.sdk.OmAds;
import com.openmediation.sdk.interstitial.InterstitialAdListener;
import com.openmediation.sdk.utils.error.Error;
import com.openmediation.sdk.utils.model.Scene;
import com.openmediation.sdk.video.RewardedVideoAd;
import com.openmediation.sdk.video.RewardedVideoListener;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.Date;

public class BaseApp extends Application {

    private static final String TAG = "BaseApp";
    public static BaseApp baseApp;
    public static Activity currentActivity;

    public static Pack5AppOpenAds appLifecycleObserver;

    public static AdModel adModel;
    public static int adTime = 2;

    public void onCreate() {
        super.onCreate();


        MobileAds.initialize(
                this,
                initializationStatus -> {
                });
        AudienceNetworkAds.initialize(this);
        AudienceNetworkInitializeHelper.initialize(this);
        appLifecycleObserver = new Pack5AppOpenAds(this);
        ProcessLifecycleOwner.get().getLifecycle().addObserver(appLifecycleObserver);
        baseApp = this;

    }


    @Override
    protected void attachBaseContext(Context base) {
        super.attachBaseContext(base);
    }


    public static BaseApp getInstance(Activity activity) {
        currentActivity = activity;
        baseApp.makeAPICall();

        return baseApp;
    }

    void loadOpenMediation() {
        com.openmediation.sdk.interstitial.InterstitialAd.setAdListener(new InterstitialAdListener() {
            @Override
            public void onInterstitialAdAvailabilityChanged(boolean available) {
                Log.e(TAG, "onInterstitialAdShowFailed: " + String.valueOf(available));

                // Change the interstitial ad state in app according to param available.
            }

            @Override
            public void onInterstitialAdShowed(Scene scene) {
                // Do not perform heavy tasks till the ad is going to be closed.
            }

            /**
             * Invoked when the Interstitial ad is closed.
             * Your activity will regain focus.
             */
            @Override
            public void onInterstitialAdClosed(Scene scene) {
                com.openmediation.sdk.interstitial.InterstitialAd.loadAd();
            }

            /**
             * Invoked when the user clicked on the Interstitial ad.
             */
            @Override
            public void onInterstitialAdClicked(Scene scene) {
            }

            /* Invoked when the Interstitial ad has showed failed
             * @param - error contains the reason for the failure:
             */
            @Override
            public void onInterstitialAdShowFailed(Scene scene, Error error) {
                Log.e(TAG, "onInterstitialAdShowFaileds: " + error.getErrorMessage());
                loadOpenMediation();
                // Interstitial ad show failed
            }
        });
        com.openmediation.sdk.interstitial.InterstitialAd.loadAd();
    }

    void loadOpenMediationRewards() {
        RewardedVideoAd.setAdListener(new RewardedVideoListener() {

            /**
             * Invoked when the ad availability status is changed.
             *
             * @param available is a boolean.
             *      True: means the rewarded videos is available and
             *          you can show the video by calling RewardedVideoAd.showAd().
             *      False: means no videos are available
             */
            @Override
            public void onRewardedVideoAvailabilityChanged(boolean available) {
                // Change the rewarded video state according to availability in app.
                // You could show ad right after it's was loaded here
            }

            /**
             * Invoked when the RewardedVideo ad view has opened.
             * Your activity will lose focus.
             */
            @Override
            public void onRewardedVideoAdShowed(Scene scene) {
                // Do not perform heavy tasks till the video ad is going to be closed.
            }

            /**
             * Invoked when the call to show a rewarded video has failed
             * @param error contains the reason for the failure:
             */
            @Override
            public void onRewardedVideoAdShowFailed(Scene scene, Error error) {
                // Video Ad show failed
                loadOpenMediationRewards();
            }

            /**
             * Invoked when the user clicked on the RewardedVideo ad.
             */
            @Override
            public void onRewardedVideoAdClicked(Scene scene) {
                // Video Ad is clicked
            }

            /**
             * Invoked when the RewardedVideo ad is closed.
             * Your activity will regain focus.
             */
            @Override
            public void onRewardedVideoAdClosed(Scene scene) {
                // Video Ad Closed
                loadOpenMediationRewards();
            }

            /**
             * Invoked when the RewardedVideo ad start to play.
             * NOTE:You may not receive this callback on some AdNetworks.
             */
            @Override
            public void onRewardedVideoAdStarted(Scene scene) {
                // Video Ad Started
            }

            /**
             * Invoked when the RewardedVideo ad play end.
             * NOTE:You may not receive this callback on some AdNetworks.
             */
            @Override
            public void onRewardedVideoAdEnded(Scene scene) {
                // Video Ad play end
            }

            /**
             * Invoked when the video is completed and the user should be rewarded.
             * If using server-to-server callbacks you may ignore this events and wait
             * for the callback from the OpenMediation server.
             */
            @Override
            public void onRewardedVideoAdRewarded(Scene scene) {
                // Here you can reward the user according to your in-app settings.
            }
        });
        RewardedVideoAd.loadAd();
    }

    void loadOpenMediationSplash() {
        Log.e(TAG, "loadOpenMediationSplash: " + adModel.getOpenmediationSplashplacementId());
        com.openmediation.sdk.splash.SplashAd.setSplashAdListener(adModel.getOpenmediationSplashplacementId(), new com.openmediation.sdk.splash.SplashAdListener() {
            @Override
            public void onSplashAdLoaded(String s) {
                com.openmediation.sdk.splash.SplashAd.showAd(adModel.getOpenmediationSplashplacementId());
            }

            @Override
            public void onSplashAdFailed(String s, Error error) {

                Log.e(TAG, "onSplashAdFailed: " + error.getErrorMessage());
            }

            @Override
            public void onSplashAdClicked(String s) {

            }

            @Override
            public void onSplashAdShowed(String s) {

            }

            @Override
            public void onSplashAdShowFailed(String s, Error error) {
                Log.e(TAG, "onSplashAdFailed: " + error.getErrorMessage());
            }

            @Override
            public void onSplashAdTick(String s, long l) {

            }

            @Override
            public void onSplashAdDismissed(String s) {
                com.openmediation.sdk.splash.SplashAd.loadAd(adModel.getOpenmediationSplashplacementId());

            }
        });
        com.openmediation.sdk.splash.SplashAd.loadAd(adModel.getOpenmediationSplashplacementId());


    }

    private void makeAPICall() {
        RequestQueue queue = Volley.newRequestQueue(currentActivity.getApplicationContext());
        String url = "http://erpsystem.sattechnolab.com/api/app_json?bundleName=" + currentActivity.getPackageName();

        StringRequest stringRequest = new StringRequest(Request.Method.GET, url,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        JSONObject jsonObject = null;
                        try {
                            Pack5AdsUtils.setOpenAdsShowedCount(0);
                            SharedPreferencesClass.getInstance().setBoolean("isSplash", true);
                            jsonObject = new JSONObject(response);
                            Gson gson = new GsonBuilder().create();

                            adModel = gson.fromJson(jsonObject.toString(), AdModel.class);

                            if (adModel.isIscheckmarket())
                                adModel.setIsad(installedFromMarket(currentActivity.getApplicationContext()));
                            if (adModel.isIscheckmarket())
                                adModel.setIsquize(installedFromMarket(currentActivity.getApplicationContext()));
                            setAppData(adModel);
                            if (adModel != null) {
                                if (adModel.isIsadmobad()) {
                                    try {
                                        ApplicationInfo ai = getPackageManager().getApplicationInfo(getPackageName(), PackageManager.GET_META_DATA);
                                        Bundle bundle = ai.metaData;
                                        String myApiKey = bundle.getString("com.google.android.gms.ads.APPLICATION_ID");
                                        Log.d(TAG, "Name Found: " + myApiKey);
                                        ai.metaData.putString("com.google.android.gms.ads.APPLICATION_ID", BaseApp.adModel.getGetAdmobKey());//you can replace your key APPLICATION_ID here
                                        String ApiKey = bundle.getString("com.google.android.gms.ads.APPLICATION_ID");
                                        Log.d(TAG, "ReNamed Found: " + ApiKey);
                                    } catch (PackageManager.NameNotFoundException e) {
                                        Log.e(TAG, "Failed to load meta-data, NameNotFound: " + e.getMessage());
                                    } catch (NullPointerException e) {
                                        Log.e(TAG, "Failed to load meta-data, NullPointer: " + e.getMessage());
                                    }
                                }
                                if (adModel.isIsopenmediation()) {
                                    InitConfiguration configuration = new InitConfiguration.Builder()
                                            .appKey(adModel.getOpenmediationKey())
                                            .logEnable(true)
                                            .build();
                                    OmAds.init(configuration, new InitCallback() {

                                        // Invoked when the initialization is successful.
                                        @Override
                                        public void onSuccess() {
                                            loadOpenMediation();
                                            loadOpenMediationRewards();
                                            loadOpenMediationSplash();
                                        }

                                        @Override
                                        public void onError(Error error) {

                                        }
                                    });
                                }

                                if (adModel.isIsad()) {
                                    adTime = adModel.getAdTime();
                                }
                            }
                        } catch (JSONException e) {
                            Log.e(TAG, "onResponse: " + e.getMessage());
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                NetworkResponse response = error.networkResponse;
                if (response != null && response.data != null) {
                    Toast.makeText(getApplicationContext(), "errorMessage:" + response.statusCode, Toast.LENGTH_SHORT).show();
                }
                String errorMessage = error.getClass().getSimpleName();
                Log.e(TAG, "onResponse: " + errorMessage);
                String message = "";
                if (error instanceof NetworkError) {
                    message = "Cannot connect to Internet...Please check your connection!";
                } else if (error instanceof ServerError) {
                    message = "The server could not be found. Please try again after some time!!";
                } else if (error instanceof AuthFailureError) {
                    message = "Cannot connect to Internet...Please check your connection!";
                } else if (error instanceof ParseError) {
                    message = "Parsing error! Please try again after some time!!";
                } else if (error instanceof TimeoutError) {
                    message = "Connection TimeOut! Please check your internet connection.";
                }

                Log.e(TAG, "onErrorResponse: " + message);
            }
        });
        queue.add(stringRequest);

    }

    private void setAppData(AdModel appData) {

        try {
            if (adModel.isIsad()) {
                Pack5AdsPreferenceClass.setAdtype("adx");
            }
            if (adModel.isIsadmobad()) {
                Pack5AdsPreferenceClass.setAdtype("admob");
            }
            if (adModel.isFacebook()) {
                Pack5AdsPreferenceClass.setAdtype("facebook");
            }
            Pack5AdsPreferenceClass.setAllAdEnable(appData.isIsad() ? 1 : 0);
            Pack5AdsPreferenceClass.setEnableBanner(appData.isIsbannerenable() ? 1 : 0);
            Pack5AdsPreferenceClass.setEnableInterstitial(appData.isIsinterstitialenable() ? 1 : 0);
            Pack5AdsPreferenceClass.setEnableNative(appData.isIsnativeenable() ? 1 : 0);
            Pack5AdsPreferenceClass.setEnableOpenad(appData.isIsopenenable() ? 1 : 0);

            Pack5AdsPreferenceClass.setInterstitialAdClick(appData.getAdTime());
//            Pack5AdsPreferenceClass.setInterstitialAdSession(appData.getInterstitialAdSession());
//            Pack5AdsPreferenceClass.setInterstitialExitAdEnable(appData.getInterstitialExitAdEnable());
            Pack5AdsPreferenceClass.setAppOpenCount(10);
            Pack5AdsPreferenceClass.setSplashOn(1);
//            Pack5AdsPreferenceClass.setSplashTime(appData.getSplashTime());

            Pack5AdsPreferenceClass.setAdmobBannerId(appData.getAdmobbannerAd());
            Pack5AdsPreferenceClass.setAdmobNativeId(appData.getAdmobnativeAd());
            Pack5AdsPreferenceClass.setAdmobInterstitialId(appData.getAdmobinterstitial());
            Pack5AdsPreferenceClass.setAdmobOpenadId(appData.getAdmobadOpen());

            Pack5AdsPreferenceClass.setAdxBannerId(appData.getBannerAd());
            Pack5AdsPreferenceClass.setAdxNativeId(appData.getNativeAd());
            Pack5AdsPreferenceClass.setAdxInterstitialId(appData.getInterstitial());
            Pack5AdsPreferenceClass.setAdxOpenadId(appData.getAdOpen());

            Pack5AdsPreferenceClass.setFbBannerId(appData.getFBbannerAd());
            Pack5AdsPreferenceClass.setFbNativeId(appData.getFBnativeAd());
            Pack5AdsPreferenceClass.setFbInterstitialId(appData.getFBinterstitialAd());
            Pack5AdsPreferenceClass.setFbNativeBannerId(appData.getFBnativeAd());
            Pack5AdsPreferenceClass.setIsRecycleNative(appData.isRecyclenative());
            if (!adModel.isIscustomeads()) {
                Pack5AdsPreferenceClass.setNativeType("normal");
            } else {
                Pack5AdsPreferenceClass.setNativeType("");
            }

        } catch (Exception e) {
            Pack5AdsUtils.PrintLog("Exception::::::::::", e.getMessage());
        }
    }
}
