package com.demoad.plugin_codelab;

import static com.demoad.plugin_codelab.ASDK.BaseApp.adModel;
import static com.demoad.plugin_codelab.ASDK.BaseApp.currentActivity;
import static com.demoad.plugin_codelab.adhelper.utils.Pack5AdsAvailability.isNetworkConnected;

import android.app.Activity;
import android.app.Application;
import android.os.Build;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.lifecycle.ProcessLifecycleOwner;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;

import com.demoad.plugin_codelab.ASDK.BaseApp;
import com.demoad.plugin_codelab.ASDK.ads;
import com.demoad.plugin_codelab.ASDK.isAdLoaded;
import com.demoad.plugin_codelab.adhelper.ads.Pack5AdManager;
import com.demoad.plugin_codelab.adhelper.ads.Pack5AppOpenAds;
import com.demoad.plugin_codelab.adhelper.helpers.AdsLoadingDialog;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsPreferenceClass;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsUtils;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AppOpenAdsListners;
import com.google.android.gms.ads.AdError;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.FullScreenContentCallback;
import com.google.android.gms.ads.LoadAdError;
import com.google.android.gms.ads.appopen.AppOpenAd;

import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * PluginCodelabPlugin
 */
public class PluginCodelabPlugin implements FlutterPlugin, MethodCallHandler, ActivityAware {
    private MethodChannel channel;
    private static final String channelName = "ads";
    ActivityPluginBinding binding;
    FlutterPluginBinding flutterPluginBinding;
    public AppOpenAd appOpenAd;
    private boolean isAppOpenAdLoad = false;

    private void setup(PluginCodelabPlugin plugin, BinaryMessenger binaryMessenger) {
        plugin.channel = new MethodChannel(binaryMessenger, channelName);

        plugin.channel.setMethodCallHandler(plugin);

    }


    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
        this.flutterPluginBinding = flutterPluginBinding;
        setup(this, flutterPluginBinding.getBinaryMessenger());

    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
        switch (call.method) {
            case "Adopen":
                callAppOpen();
                result.success(true);
                break;
            case "Interstitial":
                new ads().showIntAds(adLoaded -> {
                    result.success(true);
                });
                break;
            case "showreward":
                new ads().showreward();
                break;
            case "CloseInterstitial":
                new ads().CloseActivityWithAds(binding.getActivity(), adLoaded -> {
                    result.success(true);
                });
                break;
            case "quiz":
                result.success(adModel.getQlink());
                break;
            case "isAD":
                result.success(adModel.isIsad());
                break;
            case "isQuizeAd":
                result.success(adModel.isIsquize());
                break;
            case "onesignalKey":
                result.success(adModel.getOneSignalApp());
                break;
            case "privacyPolicy":
                result.success(adModel.getPrivacypolicy());
                break;
            case "dummyScreen":
                result.success(adModel.isIsdummyscreen());
                break;
            case "loaderUrl":
                result.success(adModel.getLoaderUrl());
                break;
            case "issdkads":
                result.success(adModel.isIssdkads());
                break;
            case "FBrewardedAd":
                result.success(adModel.isFBrewardedAd());
                break;
            case "FBinterstitialAd":
                result.success(adModel.isFBinterstitialAd());
                break;
            case "FBnativeAd":
                result.success(adModel.isFBnativeAd());
                break;
            case "FBbannerAd":
                result.success(adModel.isFBbannerAd());
                break;
            case "isEveryads":
                result.success(adModel.isIseveryads());
                break;
            case "isfacebookads":
                result.success(adModel.isIsopenmediation());
                break;
            case "isBackgroudAds":
                result.success(adModel.isIsbackgroundads());
                break;
            case "colors":
                HashMap<String, String> mapColors = new HashMap<String, String>();
                mapColors.put("background", adModel.getCustomBackgroundColor());
                mapColors.put("button", adModel.getCustomButtoncolor());
                mapColors.put("text", adModel.getCustomTextcolor());
                mapColors.put("title", adModel.getCustomTitleColor());
                result.success(mapColors);
                break;
            case "adManagerIds":
                HashMap<String, String> adManagerIds = new HashMap<String, String>();
                adManagerIds.put("banner", adModel.getBannerAd());
                adManagerIds.put("native", adModel.getNativeAd());
                adManagerIds.put("interstitial", adModel.getInterstitial());
                adManagerIds.put("reward", adModel.getFBrewardedAd());
                result.success(adManagerIds);

            case "isCustomeads":
                result.success(adModel.isIscustomeads());
                break;

            case "isnativead":
                if (adModel.isIsad()) {
                    result.success(adModel.isIsnativeenable());
                } else {
                    result.success(false);
                }
                break;
            case "isrecycleAds":
                result.success(adModel.isRecyclenative());
                break;

            default:
                result.notImplemented();
                break;
        }
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        channel.setMethodCallHandler(null);
    }

    @Override
    public void onAttachedToActivity(ActivityPluginBinding binding) {
        this.binding = binding;
        flutterPluginBinding.getFlutterEngine().getPlatformViewsController()
                .getRegistry()
                .registerViewFactory("plugins/blur_view_widget", new NativeViewFactory(binding.getActivity()));
        flutterPluginBinding.getFlutterEngine().getPlatformViewsController()
                .getRegistry()
                .registerViewFactory("plugins/blur_view_banner_widget", new BannerViewFactory(binding.getActivity()));
        BaseApp.getInstance(binding.getActivity());
        callAppOpen();

    }

    @Override
    public void onDetachedFromActivity() {
    }

    @Override
    public void onReattachedToActivityForConfigChanges(ActivityPluginBinding binding) {
        onAttachedToActivity(binding);
    }

    @Override
    public void onDetachedFromActivityForConfigChanges() {
    }

    private void callAppOpen() {
        if (Pack5AdsPreferenceClass.getAllAdEnable() == 1 && !Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.FB)) {

            if (Pack5AdsPreferenceClass.getEnableOpenad() == 1) {
                loadOpenAppAdsOnSplash(currentActivity, isLoaded -> {
                    Pack5AdsUtils.PrintLog("Ads ", "OpenApp loadOpenAppAdsOnSplash:  " + isLoaded);
                    if (isLoaded && !currentActivity.isFinishing() && !currentActivity.isDestroyed()) {
                        AdsLoadingDialog.dismissAdsLoadingDialog(currentActivity);
                        Pack5AdsUtils.PrintLog("Ads Next", "From OpenApp Load");
                        isAppOpenAdLoad = true;

                        if (!currentActivity.isFinishing()) showAppOpenAdOnSplash();
                    }
                });
            }

            new Handler(Looper.myLooper()).postDelayed(() -> {
                if (!isAppOpenAdLoad) {
                    AdsLoadingDialog.dismissAdsLoadingDialog(currentActivity);
                    Pack5AdsUtils.PrintLog("Ads Next ", "From OpenApp Time Out");
                }
            }, Pack5AdsPreferenceClass.getSplashTime() * 1000L);
        } else {
            AdsLoadingDialog.dismissAdsLoadingDialog(currentActivity);
        }
    }

    public void loadOpenAppAdsOnSplash(Activity activity, Pack5AppOpenAdsListners appCallBackOpenAppAds) {

        if (Pack5AdsPreferenceClass.getAllAdEnable() != 1) {
            return;
        }

        if (Pack5AdsPreferenceClass.getEnableOpenad() != 1) {
            return;
        }

        if (!isNetworkConnected(activity)) {
            return;
        }


        String adUnitId;
        if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.ADMOB)) {
            adUnitId = Pack5AdsPreferenceClass.getAdmobOpenadId();
        } else if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.ADX)) {
            adUnitId = Pack5AdsPreferenceClass.getAdxOpenadId();
        } else {
            return;
        }
        if (adUnitId == null) {
            return;
        }
        if (adUnitId.isEmpty()) {
            return;
        }
        Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "AppOpen Ads Splash ==>  onAdLoaded");
        AppOpenAd.load(currentActivity, adUnitId, new AdRequest.Builder().build(), AppOpenAd.APP_OPEN_AD_ORIENTATION_PORTRAIT, new AppOpenAd.AppOpenAdLoadCallback() {
            @Override
            public void onAdLoaded(@NonNull AppOpenAd ad) {
                appOpenAd = ad;
                appCallBackOpenAppAds.onAdLoad(true);
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "AppOpen Ads Splash ==>  onAdLoaded");
            }

            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                appOpenAd = null;
                appCallBackOpenAppAds.onAdLoad(false);
                Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "AppOpen Ads Splash ==>  onAdFailedToLoad");
            }
        });
    }

    private void showAppOpenAdOnSplash() {
        if (!Pack5AdsUtils.isShowingFullScreenAd && appOpenAd != null && isNetworkConnected(currentActivity) && Pack5AdsPreferenceClass.getSplashOn() == 1) {

            FullScreenContentCallback callback = new FullScreenContentCallback() {
                @Override
                public void onAdDismissedFullScreenContent() {

                    appOpenAd = null;

                    Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "AppOpen Ads Splash ==> onAdDismissedFullScreenContent");
                }

                @Override
                public void onAdFailedToShowFullScreenContent(@NonNull AdError adError) {
                    Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "AppOpen Ads Splash ==> onAdFailedToShowFullScreenContent \n" + adError.getMessage());
                }

                @Override
                public void onAdShowedFullScreenContent() {
                    Pack5AdsUtils.PrintLog(Pack5AdManager.PACK5_ADMOB_TAG, "AppOpen Ads Splash ==> onAdShowedFullScreenContent");
                }
            };
            appOpenAd.setFullScreenContentCallback(callback);
            appOpenAd.show(currentActivity);
        }

    }
}
