package com.demoad.plugin_codelab.adhelper.ads;

import android.app.Activity;
import android.text.TextUtils;
import android.util.Log;

import androidx.annotation.NonNull;

import com.demoad.plugin_codelab.adhelper.helpers.AdsLoadingDialog;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsAvailability;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsPreferenceClass;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsUtils;
import com.facebook.ads.AbstractAdListener;
import com.facebook.ads.Ad;
import com.google.android.gms.ads.AdError;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.FullScreenContentCallback;
import com.google.android.gms.ads.LoadAdError;
import com.google.android.gms.ads.admanager.AdManagerAdRequest;
import com.google.android.gms.ads.admanager.AdManagerInterstitialAd;
import com.google.android.gms.ads.admanager.AdManagerInterstitialAdLoadCallback;
import com.google.android.gms.ads.interstitial.InterstitialAd;
import com.google.android.gms.ads.interstitial.InterstitialAdLoadCallback;

public class Pack5Interstitial {

    //InterstitialAd
    public static InterstitialAd mInterstitialAd;
    public static AdManagerInterstitialAd mAdManagerInterstitialAd;
    public static com.facebook.ads.InterstitialAd fbInterstitialAd;

    public static void showFullInterstitialAdsMain(Activity activity,boolean countClicks, OnInterstitialAdsListner listner) {

        Pack5AdsAvailability.isInterstitialAvailability(activity,countClicks, new Pack5AdsAvailability.onReturnAdsTypeListner() {
            @Override
            public void onAdMobAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Admob Interstitial Enable ====>");
                loadAdmobInterstitialAd(activity, listner);
            }

            @Override
            public void onAdxAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Adx Interstitial Enable ====>");
                loadAdxInterstitialAd(activity, listner);
            }

            @Override
            public void onFbAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== FB Interstitial Enable ====>");
                loadFbInterstitialAd(activity, listner);
            }

            @Override
            public void onEmpty() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== All Interstitial Disable ====>");
                listner.onFinishInterstitialAds();
            }
        });

    }

    //Admob
    private static void loadAdmobInterstitialAd(Activity activity, OnInterstitialAdsListner listner) {

        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getAdmobInterstitialId();

        Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob InterstitialAd ID ==> " + adUnitId);
        if (TextUtils.isEmpty(adUnitId)) {
            loadAdxInterstitialAd(activity, listner);
            return;
        }
        AdsLoadingDialog.showAdsLoadingDialog(activity);

        AdRequest adRequest = new AdRequest.Builder().build();
        InterstitialAd.load(activity, adUnitId, adRequest, new InterstitialAdLoadCallback() {
            @Override
            public void onAdLoaded(@NonNull InterstitialAd interstitialAd) {
                mInterstitialAd = interstitialAd;
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob InterstitialAd ==> onAdLoaded");
                AdsLoadingDialog.dismissAdsLoadingDialog(activity);
                displayAdMobInterstitialAd(activity, listner);
            }

            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                // Handle the error
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob InterstitialAd ==> onAdFailedToLoad \n" + loadAdError.getMessage());
                mInterstitialAd = null;
                loadAdxInterstitialAd(activity, listner);
            }
        });
    }

    private static void displayAdMobInterstitialAd(Activity activity, OnInterstitialAdsListner listner) {

        if (mInterstitialAd != null) {
            Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob InterstitialAd ==> " + "showing");
            mInterstitialAd.show(activity);
            Pack5AdsUtils.isShowingFullScreenAd = true;
            Pack5AdsUtils.ads_per_session++;
        } else {
            Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob InterstitialAd ==> " + "Fail to showing -> Reload");
            loadAdmobInterstitialAd(activity, listner);
            Pack5AdsUtils.isShowingFullScreenAd = false;
            return;
        }


        if (mInterstitialAd != null) {
            mInterstitialAd.setFullScreenContentCallback(new FullScreenContentCallback() {
                @Override
                public void onAdDismissedFullScreenContent() {
                    // Called when fullscreen content is dismissed.
                    Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob InterstitialAd ==> onAdDismissedFullScreenContent");
                    listner.onFinishInterstitialAds();
                    Pack5AdsUtils.isShowingFullScreenAd = false;
                }

                @Override
                public void onAdFailedToShowFullScreenContent(@NonNull AdError adError) {
                    Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob InterstitialAd ==> onAdFailedToShowFullScreenContent \n" + adError.getMessage());
                }

                @Override
                public void onAdShowedFullScreenContent() {
                    mInterstitialAd = null;
                    Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob InterstitialAd ==> onAdShowedFullScreenContent");
                }
            });
        }
    }

    //AdX
    private static void loadAdxInterstitialAd(Activity activity, OnInterstitialAdsListner listner) {

        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getAdxInterstitialId();

        Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx InterstitialAd ===> " + adUnitId);
        if (TextUtils.isEmpty(adUnitId)) {
            loadFbInterstitialAd(activity, listner);
            return;
        }
        AdsLoadingDialog.showAdsLoadingDialog(activity);

        AdManagerAdRequest adManagerAdRequest = new AdManagerAdRequest.Builder().build();
        AdManagerInterstitialAd.load(activity, adUnitId, adManagerAdRequest, new AdManagerInterstitialAdLoadCallback() {
            @Override
            public void onAdLoaded(@NonNull AdManagerInterstitialAd interstitialAd) {
                mAdManagerInterstitialAd = interstitialAd;
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx InterstitialAd ==>" + "onAdLoaded");
                AdsLoadingDialog.dismissAdsLoadingDialog(activity);
                displayAdxInterstitialAd(activity, listner);
            }

            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                // Handle the error
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx InterstitialAd ==> onAdFailedToLoad \n" + loadAdError.getMessage());
                mAdManagerInterstitialAd = null;
                loadFbInterstitialAd(activity, listner);
            }
        });

    }

    private static void displayAdxInterstitialAd(Activity activity, OnInterstitialAdsListner listner) {

        if (mAdManagerInterstitialAd != null) {
            Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx InterstitialAd ===> " + "Showing");
            mAdManagerInterstitialAd.show(activity);
            Pack5AdsUtils.isShowingFullScreenAd = true;
            Pack5AdsUtils.ads_per_session++;
        } else {
            Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx InterstitialAd ==> " + "Fail to showing -> Reload");
            loadAdxInterstitialAd(activity, listner);
            Pack5AdsUtils.isShowingFullScreenAd = false;
            return;
        }


        if (mAdManagerInterstitialAd != null) {
            mAdManagerInterstitialAd.setFullScreenContentCallback(new FullScreenContentCallback() {
                @Override
                public void onAdDismissedFullScreenContent() {
                    // Called when fullscreen content is dismissed.
                    Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx InterstitialAd ==> onAdDismissedFullScreenContent");
                    listner.onFinishInterstitialAds();
                    Pack5AdsUtils.isShowingFullScreenAd = false;
                }

                @Override
                public void onAdFailedToShowFullScreenContent(@NonNull AdError adError) {
                    Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx InterstitialAd ==> onAdFailedToShowFullScreenContent\n" + adError.getMessage());
                }

                @Override
                public void onAdShowedFullScreenContent() {
                    mAdManagerInterstitialAd = null;
                    Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx InterstitialAd ==> onAdShowedFullScreenContent");
                }
            });
        }
    }

    //FB
    private static void loadFbInterstitialAd(Activity activity, OnInterstitialAdsListner listner) {

        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getFbInterstitialId();

        Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB InterstitialAd ID ===> " + adUnitId);
        AdsLoadingDialog.showAdsLoadingDialog(activity);

        fbInterstitialAd = new com.facebook.ads.InterstitialAd(activity, adUnitId);
        AbstractAdListener adListener = new AbstractAdListener() {
            @Override
            public void onError(Ad ad, com.facebook.ads.AdError error) {
                super.onError(ad, error);
                AdsLoadingDialog.dismissAdsLoadingDialog(activity);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Fb InterstitialAd ==> onError \n" + error.getErrorMessage());
                listner.onFinishInterstitialAds();
            }

            @Override
            public void onAdLoaded(Ad ad) {
                super.onAdLoaded(ad);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Fb InterstitialAd ==> onAdLoaded");
                Pack5AdsUtils.isShowingFullScreenAd = false;
                displayFbInterstitialAd(activity, listner);
            }

            @Override
            public void onAdClicked(Ad ad) {
                super.onAdClicked(ad);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Fb InterstitialAd ==> onAdClicked");
            }

            @Override
            public void onInterstitialDisplayed(Ad ad) {
                super.onInterstitialDisplayed(ad);
                AdsLoadingDialog.dismissAdsLoadingDialog(activity);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB InterstitialAd ==> onInterstitialDisplayed");
            }

            @Override
            public void onInterstitialDismissed(Ad ad) {
                super.onInterstitialDismissed(ad);
                AdsLoadingDialog.dismissAdsLoadingDialog(activity);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB InterstitialAd ==> onInterstitialDismissed");
                Pack5AdsUtils.isShowingFullScreenAd = false;
                listner.onFinishInterstitialAds();
            }
        };
        com.facebook.ads.InterstitialAd.InterstitialLoadAdConfig interstitialLoadAdConfig = fbInterstitialAd.buildLoadAdConfig().withAdListener(adListener).build();
        fbInterstitialAd.loadAd(interstitialLoadAdConfig);
    }

    private static void displayFbInterstitialAd(Activity activity, OnInterstitialAdsListner listner) {
        if (fbInterstitialAd != null) {
            Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB InterstitialAd ===> " + "showing");
            fbInterstitialAd.show();
            Pack5AdsUtils.isShowingFullScreenAd = true;
            Pack5AdsUtils.ads_per_session++;
        } else {
            Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB InterstitialAd ==> " + "Fail to showing -> Reload");
            loadFbInterstitialAd(activity, listner);
            Pack5AdsUtils.isShowingFullScreenAd = false;
        }
    }

    public interface OnInterstitialAdsListner {
        void onFinishInterstitialAds();
    }

}
