package com.demoad.plugin_codelab.adhelper.ads;

import static com.demoad.plugin_codelab.ASDK.BaseApp.currentActivity;
import static com.demoad.plugin_codelab.adhelper.ads.Pack5NativeSmallUp.addTitleColor;

import android.app.Activity;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;

import com.facebook.ads.Ad;
import com.facebook.ads.AdOptionsView;
import com.google.android.gms.ads.AdListener;
import com.google.android.gms.ads.AdLoader;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.LoadAdError;
import com.google.android.gms.ads.VideoOptions;
import com.google.android.gms.ads.admanager.AdManagerAdRequest;
import com.google.android.gms.ads.nativead.NativeAd;
import com.google.android.gms.ads.nativead.NativeAdOptions;
import com.google.android.gms.ads.nativead.NativeAdView;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

import com.demoad.plugin_codelab.R;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsAvailability;
import com.demoad.plugin_codelab.adhelper.utils.Pack5AdsPreferenceClass;

public class Pack5NativeSmallDown_Nomedia {

    public static NativeAd mPack5NativeAdsSmall = null;

    /*//
    //Small
    //*/

    public static void showNativeAdsSmallMain(ViewGroup fl_adplaceholder, Activity activity) {


        Pack5AdsAvailability.isNativeAvailability(activity, new Pack5AdsAvailability.onReturnAdsTypeListner() {
            @Override
            public void onAdMobAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Admob Native Small Enable ====>");
                if (mPack5NativeAdsSmall != null) {
                    mPack5NativeAdsSmall.destroy();
                    mPack5NativeAdsSmall = null;
                }
                loadAdmobNativeAdSmall(fl_adplaceholder, activity);
            }

            @Override
            public void onAdxAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Adx Native Small Enable ====>");
                if (mPack5NativeAdsSmall != null) {
                    mPack5NativeAdsSmall.destroy();
                    mPack5NativeAdsSmall = null;
                }
                loadAdxNativeAdSmall(fl_adplaceholder, activity);
            }

            @Override
            public void onFbAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== FB Native Small Enable ====>");
                loadFbNativeAdSmall(fl_adplaceholder, activity);
            }

            @Override
            public void onEmpty() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== All Native Small Disable ====>");
                fl_adplaceholder.setVisibility(View.GONE);
            }
        });
    }

    public static void showNativeAdsSmallMainList(ViewGroup fl_adplaceholder, Activity activity) {


        Pack5AdsAvailability.isNativeAvailability(activity, new Pack5AdsAvailability.onReturnAdsTypeListner() {
            @Override
            public void onAdMobAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Admob Native Small Enable ====>");
                if (mPack5NativeAdsSmall != null) {
                    mPack5NativeAdsSmall.destroy();
                    mPack5NativeAdsSmall = null;
                }
                loadAdmobNativeAdSmall(fl_adplaceholder, activity);
            }

            @Override
            public void onAdxAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== Adx Native Small Enable ====>");
                if (mPack5NativeAdsSmall != null) {
                    mPack5NativeAdsSmall.destroy();
                    mPack5NativeAdsSmall = null;
                }
                loadAdxNativeAdSmall(fl_adplaceholder, activity);
            }

            @Override
            public void onFbAdAvailability() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== FB Native Small Enable ====>");
                loadFbNativeAdSmall(fl_adplaceholder, activity);
            }

            @Override
            public void onEmpty() {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "<==== All Native Small Disable ====>");
                fl_adplaceholder.setVisibility(View.GONE);
            }
        });


    }


    /*load native*/
    //admob
    public static void loadAdmobNativeAdSmall(ViewGroup fl_adplaceholder , Activity activity) {

        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getAdmobNativeId();


        if (TextUtils.isEmpty(adUnitId)) {
            loadAdxNativeAdSmall(fl_adplaceholder, activity);
            return;
        }

        Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob Native Ads Small ID ==> \n" + adUnitId);

        AdLoader.Builder builder = new AdLoader.Builder(activity, adUnitId);

        builder.forNativeAd(nativeAd -> {
            mPack5NativeAdsSmall = nativeAd;
            showNativeOptionAdSmall(fl_adplaceholder, activity);

        }).withAdListener(new AdListener() {

            @Override
            public void onAdLoaded() {
                super.onAdLoaded();
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob Native Ads Small ==> " + "onAdLoaded");
            }

            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                super.onAdFailedToLoad(loadAdError);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob Native Ads Small ==> \n" + loadAdError.getMessage());
            }
        });

        VideoOptions videoOptions = new VideoOptions.Builder().setStartMuted(true).build();

        NativeAdOptions adOptions = new NativeAdOptions.Builder().setVideoOptions(videoOptions).build();

        builder.withNativeAdOptions(adOptions);
        AdLoader adLoader = builder.withAdListener(new AdListener() {
            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError adError) {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Admob Native Ads Small ==> onAdFailedToLoad \n" + adError.getMessage());
                loadAdxNativeAdSmall(fl_adplaceholder, activity);

            }
        }).build();

        adLoader.loadAd(new AdRequest.Builder().build());

    }

    /*load native*/
    //adx
    public static void loadAdxNativeAdSmall(ViewGroup fl_adplaceholder , Activity activity) {

        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getAdxNativeId();


        if (TextUtils.isEmpty(adUnitId)) {
            loadFbNativeAdSmall(fl_adplaceholder, activity);
            return;
        }

        Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx Native Ads Small ID ==> \n" + adUnitId);

        AdLoader.Builder builder = new AdLoader.Builder(activity, adUnitId);

        builder.forNativeAd(nativeAd -> {
            mPack5NativeAdsSmall = nativeAd;
            showNativeOptionAdSmall(fl_adplaceholder, activity);

        }).withAdListener(new AdListener() {

            @Override
            public void onAdLoaded() {
                super.onAdLoaded();
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx Native Ads Small ==> onAdLoaded");
            }

            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                super.onAdFailedToLoad(loadAdError);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx Native Ads Small ==> onAdFailedToLoad \n" + loadAdError.getMessage());
            }
        });

        VideoOptions videoOptions = new VideoOptions.Builder().setStartMuted(true).build();

        NativeAdOptions adOptions = new NativeAdOptions.Builder().setVideoOptions(videoOptions).build();

        builder.withNativeAdOptions(adOptions);
        AdLoader adLoader = builder.withAdListener(new AdListener() {
            @Override
            public void onAdFailedToLoad(@NonNull LoadAdError adError) {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Adx Native Ads Small ==> onAdFailedToLoad \n" + adError.getMessage());
                loadFbNativeAdSmall(fl_adplaceholder, activity);
            }
        }).build();

        adLoader.loadAd(new AdManagerAdRequest.Builder().build());

    }

    /*load native*/
    //fb
    public static void loadFbNativeAdSmall(ViewGroup fl_adplaceholder , Activity activity) {

        String adUnitId;
        adUnitId = Pack5AdsPreferenceClass.getFbNativeBannerId();


        Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Fb Native Ads Small ID ==> " + adUnitId);

        com.facebook.ads.NativeBannerAd nativeBannerAd = new com.facebook.ads.NativeBannerAd(activity, adUnitId);
        com.facebook.ads.NativeAdListener nativeAdListener = new com.facebook.ads.NativeAdListener() {
            @Override
            public void onMediaDownloaded(Ad ad) {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB Native Ads Small ==> onMediaDownloaded");
            }

            @Override
            public void onError(Ad ad, com.facebook.ads.AdError adError) {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Fb Native Ads Small ==> onAdFailedToLoad \n" + adError.getErrorMessage());

            }

            @Override
            public void onAdLoaded(Ad ad) {
                if (nativeBannerAd != ad) {
                    return;
                }

                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "FB Native Ads Small ==> onAdLoaded");
                populatFbNativeBannerAd(fl_adplaceholder, activity, nativeBannerAd);
            }

            @Override
            public void onAdClicked(Ad ad) {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Fb Native Ads SMall ==> onAdClicked");
            }

            @Override
            public void onLoggingImpression(Ad ad) {
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Fb Native Ads Small ==> onLoggingImpression");
            }
        };
        // load the ad
        nativeBannerAd.loadAd(nativeBannerAd.buildLoadAdConfig().withAdListener(nativeAdListener).build());
    }

    /*show native*/
    public static void showNativeOptionAdSmall(ViewGroup fl_adplaceholder, Activity activity) {
        try {
            if (mPack5NativeAdsSmall != null) {
                NativeAdView adView = (NativeAdView) LayoutInflater.from(activity).inflate(R.layout.ad_unifiled_smalldown_nomedia, null);
                populateUnifiedNativeSmallAdView(mPack5NativeAdsSmall, adView,fl_adplaceholder);
                fl_adplaceholder.setVisibility(View.VISIBLE);
                fl_adplaceholder.removeAllViews();
                fl_adplaceholder.addView(adView);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Native Ads Small ==> Success to show");

            } else {
                fl_adplaceholder.setVisibility(View.GONE);
                Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Native Ads Small ==> null");
            }
        } catch (Exception e) {
            e.printStackTrace();
            fl_adplaceholder.setVisibility(View.GONE);
            Log.e(Pack5AdManager.PACK5_ADMOB_TAG, "Native Ads Small ==> Exception \n" + e.getMessage());

        }
    }

    /*populat native*/
    public static void populateUnifiedNativeSmallAdView(NativeAd nativeAd, NativeAdView adView, ViewGroup fl_adplaceholder) {
        adView.setHeadlineView(adView.findViewById(R.id.ad_headline));
        adView.setBodyView(adView.findViewById(R.id.ad_body));
        adView.setCallToActionView(adView.findViewById(R.id.ad_call_to_action));
        adView.setIconView(adView.findViewById(R.id.ad_app_icon));
        adView.setPriceView(adView.findViewById(R.id.ad_price));
        adView.setStarRatingView(adView.findViewById(R.id.ad_stars));
        adView.setStoreView(adView.findViewById(R.id.ad_store));
        adView.setAdvertiserView(adView.findViewById(R.id.ad_advertiser));

        try {
            ((TextView) adView.getHeadlineView()).setText(nativeAd.getHeadline());
        } catch (Exception e) {
            e.printStackTrace();
        }

        if (nativeAd.getBody() == null) {
            Objects.requireNonNull(adView.getBodyView()).setVisibility(View.INVISIBLE);
        } else {
            Objects.requireNonNull(adView.getBodyView()).setVisibility(View.VISIBLE);
            ((TextView) adView.getBodyView()).setText(nativeAd.getBody());
        }

        if (nativeAd.getCallToAction() == null) {
            Objects.requireNonNull(adView.getCallToActionView()).setVisibility(View.INVISIBLE);
        } else {
            Objects.requireNonNull(adView.getCallToActionView()).setVisibility(View.VISIBLE);
            ((TextView) adView.getCallToActionView()).setText(nativeAd.getCallToAction());
        }

        if (nativeAd.getIcon() == null) {
            Objects.requireNonNull(adView.getIconView()).setVisibility(View.GONE);
        } else {
            ((ImageView) Objects.requireNonNull(adView.getIconView())).setImageDrawable(nativeAd.getIcon().getDrawable());
            adView.getIconView().setVisibility(View.VISIBLE);
        }

        if (nativeAd.getPrice() == null) {
            Objects.requireNonNull(adView.getPriceView()).setVisibility(View.INVISIBLE);
        } else {
            Objects.requireNonNull(adView.getPriceView()).setVisibility(View.VISIBLE);
            ((TextView) adView.getPriceView()).setText(nativeAd.getPrice());
        }


        if (nativeAd.getStore() == null) {
            Objects.requireNonNull(adView.getStoreView()).setVisibility(View.INVISIBLE);
        } else {
            Objects.requireNonNull(adView.getStoreView()).setVisibility(View.VISIBLE);
            ((TextView) adView.getStoreView()).setText(nativeAd.getStore());
        }

        if (nativeAd.getStarRating() == null) {
            Objects.requireNonNull(adView.getStarRatingView()).setVisibility(View.INVISIBLE);
        } else {
            ((RatingBar) Objects.requireNonNull(adView.getStarRatingView())).setRating(nativeAd.getStarRating().floatValue());
            adView.getStarRatingView().setVisibility(View.VISIBLE);
        }

        if (nativeAd.getAdvertiser() == null) {
            Objects.requireNonNull(adView.getAdvertiserView()).setVisibility(View.INVISIBLE);
        } else {
            ((TextView) Objects.requireNonNull(adView.getAdvertiserView())).setText(nativeAd.getAdvertiser());
            adView.getAdvertiserView().setVisibility(View.VISIBLE);
        }
        adView.getStoreView().setVisibility(View.GONE);
        adView.getPriceView().setVisibility(View.GONE);
        try{
            addTitleColor(currentActivity,fl_adplaceholder,adView,nativeAd);
        }catch (Exception e) {
            e.printStackTrace();
        }
        adView.setNativeAd(nativeAd);
    }

    /*populat native*/
    // Native Banner
    private static void populatFbNativeBannerAd(ViewGroup fl_adplaceholder, Activity activity, com.facebook.ads.NativeBannerAd nativeBannerAd) {
        // Unregister last ad
        nativeBannerAd.unregisterView();

        // Add the Ad view into the ad container.

        LayoutInflater inflater = LayoutInflater.from(activity);
        // Inflate the Ad view.  The layout referenced is the one you created in the last step.
        View adView = inflater.inflate(R.layout.ad_item_native_banner_fb_small, fl_adplaceholder, false);
        fl_adplaceholder.addView(adView);

        // Add the AdChoices icon
//        RelativeLayout adChoicesContainer = adView.findViewById(R.id.ad_choices_container);
//        AdOptionsView adOptionsView = new AdOptionsView(activity, nativeBannerAd, flNativeFBSmall);
//        adChoicesContainer.removeAllViews();
//        adChoicesContainer.addView(adOptionsView, 0);

        // Create native UI using the ad metadata.
        TextView nativeAdTitle = adView.findViewById(R.id.native_ad_title);
        TextView nativeAdSocialContext = adView.findViewById(R.id.native_ad_social_context);
        TextView sponsoredLabel = adView.findViewById(R.id.native_ad_sponsored_label);
        com.facebook.ads.MediaView nativeAdIconView = adView.findViewById(R.id.native_icon_view);
        TextView nativeAdCallToAction = adView.findViewById(R.id.native_ad_call_to_action);

        // Set the Text.
        nativeAdCallToAction.setText(nativeBannerAd.getAdCallToAction());
        nativeAdCallToAction.setVisibility(nativeBannerAd.hasCallToAction() ? View.VISIBLE : View.INVISIBLE);
        nativeAdTitle.setText(nativeBannerAd.getAdvertiserName());
        nativeAdSocialContext.setText(nativeBannerAd.getAdSocialContext());
        sponsoredLabel.setText(nativeBannerAd.getSponsoredTranslation());

        // Register the Title and CTA button to listen for clicks.
        List<View> clickableViews = new ArrayList<>();
        clickableViews.add(nativeAdIconView);
        clickableViews.add(nativeAdTitle);
        clickableViews.add(nativeAdCallToAction);
        clickableViews.add(sponsoredLabel);
        clickableViews.add(nativeAdSocialContext);
        nativeBannerAd.registerViewForInteraction(adView, nativeAdIconView, clickableViews);
    }


}
