package com.demoad.plugin_codelab.adhelper.utils;

import android.app.Activity;
import android.content.Context;
import android.net.ConnectivityManager;
import android.util.Log;

public  class Pack5AdsAvailability {
    
        public interface onReturnAdsTypeListner {
            void onAdMobAdAvailability();
    
            void onAdxAdAvailability();
    
            void onFbAdAvailability();
    
            void onEmpty();
        }
    
        public static boolean isNetworkConnected(Activity activity) {
            ConnectivityManager cm = (ConnectivityManager) activity.getSystemService(Context.CONNECTIVITY_SERVICE);
            return cm.getActiveNetworkInfo() != null && cm.getActiveNetworkInfo().isConnected();
        }
    
        public static void isBannerAvailability(Activity activity, onReturnAdsTypeListner onReturnAdsTypeListner) {
    
            if (!isNetworkConnected(activity)) {
                onReturnAdsTypeListner.onEmpty();
                return;
            }
            if (Pack5AdsPreferenceClass.getAllAdEnable() != 1) {
                onReturnAdsTypeListner.onEmpty();
                return;
            }
    
            if (Pack5AdsPreferenceClass.getEnableBanner() != 1) {
                onReturnAdsTypeListner.onEmpty();
                return;
            }
    
            if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.ADMOB)) {
                onReturnAdsTypeListner.onAdMobAdAvailability();
            } else if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.ADX)) {
                onReturnAdsTypeListner.onAdxAdAvailability();
            } else if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.FB)) {
                Log.e("TAG", "fb isBannerAvailability: " + Pack5AdsPreferenceClass.getAdtype() );
                onReturnAdsTypeListner.onFbAdAvailability();
            } else {
                onReturnAdsTypeListner.onEmpty();
            }
    
        }
    
        public static void isInterstitialAvailability(Activity activity,boolean countClicks, onReturnAdsTypeListner onReturnAdsTypeListner) {
    
            if (!isNetworkConnected(activity)) {
                onReturnAdsTypeListner.onEmpty();
                return;
            }
            if (Pack5AdsPreferenceClass.getAllAdEnable() != 1) {
                onReturnAdsTypeListner.onEmpty();
                return;
            }
    
            if (Pack5AdsPreferenceClass.getEnableInterstitial() != 1) {
                onReturnAdsTypeListner.onEmpty();
                return;
            }
    
//            if (Pack5AdsUtils.ads_per_session == Pack5AdsPreferenceClass.getInterstitialAdSession()) {
//                onReturnAdsTypeListner.onEmpty();
//                return;
//            }

            if (countClicks) {
                int count = Pack5AdsUtils.getInterstitialAdsCount();

                Pack5AdsUtils.setInterstitialAdsCount(Pack5AdsUtils.getInterstitialAdsCount() + 1);
                Log.e("TAG", "isInterstitialAvailability: " + Pack5AdsUtils.getInterstitialAdsCount());
                if(Pack5AdsPreferenceClass.getInterstitialAdClick()==0){
                    onReturnAdsTypeListner.onEmpty();
                    return;
                }
                else {
                    if (count % Pack5AdsPreferenceClass.getInterstitialAdClick() != 0) {
                        onReturnAdsTypeListner.onEmpty();
                        return;
                    }
                }
            }
    
            if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.ADMOB)) {
                onReturnAdsTypeListner.onAdMobAdAvailability();
            } else if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.ADX)) {
                onReturnAdsTypeListner.onAdxAdAvailability();
            } else if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.FB)) {
                onReturnAdsTypeListner.onFbAdAvailability();
            } else {
                onReturnAdsTypeListner.onEmpty();
            }
    
        }
    
        public static void isNativeAvailability(Activity activity, onReturnAdsTypeListner onReturnAdsTypeListner) {
    
            if (!isNetworkConnected(activity)) {
                onReturnAdsTypeListner.onEmpty();
                return;
            }
            if (Pack5AdsPreferenceClass.getAllAdEnable() != 1) {
                onReturnAdsTypeListner.onEmpty();
                return;
            }
            if (Pack5AdsPreferenceClass.getEnableNative() != 1) {
                onReturnAdsTypeListner.onEmpty();
                return;
            }
    
            if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.ADMOB)) {
                onReturnAdsTypeListner.onAdMobAdAvailability();
            } else if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.ADX)) {
                onReturnAdsTypeListner.onAdxAdAvailability();
            } else if (Pack5AdsPreferenceClass.getAdtype().equalsIgnoreCase(Pack5AdsUtils.FB)) {
                onReturnAdsTypeListner.onFbAdAvailability();
            } else {
                onReturnAdsTypeListner.onEmpty();
            }
        }
    }
